



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[ML] 解决样本类别分布不均衡的问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[ML] 解决样本类别分布不均衡的问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-13 18:51:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转自：<a href="http://www.dataivy.cn/blog/3-4-%E8%A7%A3%E5%86%B3%E6%A0%B7%E6%9C%AC%E7%B1%BB%E5%88%AB%E5%88%86%E5%B8%83%E4%B8%8D%E5%9D%87%E8%A1%A1%E7%9A%84%E9%97%AE%E9%A2%98/" rel="external nofollow noreferrer">3.4 解决样本类别分布不均衡的问题 | 数据常青藤</a>&nbsp;（组织排版上稍有修改）</p>
<h1>3.4 解决样本类别分布不均衡的问题</h1>
<p>说明：本文是《Python数据分析与数据化运营》中的&ldquo;3.4 解决样本类别分布不均衡的问题&rdquo;。</p>
<p>-----------------------------下面是正文内容--------------------------</p>
<p>所谓的不平衡指的是不同类别的样本量异非常大。样本类别分布不平衡主要出现在分类相关的建模问题上。样本类别分布不均衡从数据规模上可以分为大数据分布不均衡和小数据分布不均衡两种。</p>
<ul><li>大数据分布不均衡。这种情况下整体数据规模大，只是其中的少样本类的占比较少。但是从每个特征的分布来看，小样本也覆盖了大部分或全部的特征。例如拥有1000万条记录的数据集中，其中占比50万条的少数分类样本便于属于这种情况。</li>
<li>小数据分布不均衡。这种情况下整体数据规模小，并且占据少量样本比例的分类数量也少，这会导致特征分布的严重不平衡。例如拥有1000条数据样本的数据集中，其中占有10条样本的分类，其特征无论如何拟合也无法实现完整特征值的覆盖，此时属于严重的数据样本分布不均衡。</li></ul>
<p>样本分布不均衡将导致样本量少的分类所包含的特征过少，并很难从中提取规律；即使得到分类模型，也容易产生过度依赖于有限的数据样本而导致过拟合的问题，当模型应用到新的数据上时，模型的准确性和鲁棒性将很差。</p>
<p>样本分布不平衡主要在于不同类别间的样本比例差异，以笔者的工作经验看，如果不同分类间的样本量差异达到超过10倍就需要引起警觉并考虑处理该问题，超过20倍就要一定要解决该问题。</p>
<h2>3.4.1 哪些运营场景中容易出现样本不均衡</h2>
<p>在数据化运营过程中，以下场景会经常产生样本分布不均衡的问题：</p>
<ul><li>异常检测场景。大多数企业中的异常个案都是少量的，比如恶意刷单、黄牛订单、信用卡欺诈、电力窃电、设备故障等，这些数据样本所占的比例通常是整体样本中很少的一部分，以信用卡欺诈为例，刷实体信用卡的欺诈比例一般都在0.1%以内。</li>
<li>客户流失场景。大型企业的流失客户相对于整体客户通常是少量的，尤其对于具有垄断地位的行业巨擘，例如电信、石油、网络运营商等更是如此。</li>
<li>罕见事件的分析。罕见事件与异常检测类似，都属于发生个案较少；但不同点在于异常检测通常都有是预先定义好的规则和逻辑，并且大多数异常事件都对会企业运营造成负面影响，因此针对异常事件的检测和预防非常重要；但罕见事件则无法预判，并且也没有明显的积极和消极影响倾向。例如由于某网络大V无意中转发了企业的一条趣味广告导致用户流量明显提升便属于此类。</li>
<li>发生频率低的事件。这种事件是预期或计划性事件，但是发生频率非常低。例如每年1次的双11盛会一般都会产生较高的销售额，但放到全年来看这一天的销售额占比很可能只有1%不到，尤其对于很少参与活动的公司而言，这种情况更加明显。这种属于典型的低频事件。</li></ul>
<h2>3.4.2 解决样本不均衡的方法</h2>
<h3>3.4.2.1 通过过抽样和欠抽样</h3>
<p>抽样是解决样本分布不均衡相对简单且常用的方法，包括过抽样和欠抽样两种。</p>
<ul><li>过抽样（也叫上采样、over-sampling）方法通过增加分类中少数类样本的数量来实现样本均衡，最直接的方法是简单复制少数类样本形成多条记录，这种方法的缺点是如果样本特征少而可能导致过拟合的问题；经过改进的过抽样方法通过在少数类中加入随机噪声、干扰数据或通过一定规则产生新的合成样本，例如SMOTE算法。</li>
<li>欠抽样（也叫下采样、under-sampling）方法通过减少分类中多数类样本的样本数量来实现样本均衡，最直接的方法是随机地去掉一些多数类样本来减小多数类的规模，缺点是会丢失多数类样本中的一些重要信息。</li></ul>
<p>总体上，过抽样和欠抽样更适合大数据分布不均衡的情况，尤其是第一种（过抽样）方法应用更加广泛。</p>
<h3>3.4.2.2 通过正负样本的惩罚权重</h3>
<p>通过正负样本的惩罚权重解决样本不均衡的问题的思想是在算法实现过程中，对于分类中不同样本数量的类别分别赋予不同的权重（一般思路分类中的小样本量类别权重高，大样本量类别权重低），然后进行计算和建模。</p>
<p>使用这种方法时需要对样本本身做额外处理，只需在算法模型的参数中进行相应设置即可。很多模型和算法中都有基于类别参数的调整设置，以scikit-learn中的SVM为例，通过在class_weight: {dict, 'balanced'}中针对不同类别针对不同的权重，来手动指定不同类别的权重。如果使用其默认的方法balanced，那么SVM会将权重设置为与不同类别样本数量呈反比的权重来做自动均衡处理，计算公式为：n_samples / (n_classes * np.bincount(y))。</p>
<p>如果算法本身支持，这种思路是更加简单且高效的方法。</p>
<h3>3.4.2.3 通过组合/集成方法</h3>
<p>组合/集成方法指的是在每次生成训练集时使用所有分类中的小样本量，同时从分类中的大样本量中随机抽取数据来与小样本量合并构成训练集，这样反复多次会得到很多训练集和训练模型。最后在应用时，使用组合方法（例如投票、加权投票等）产生分类预测结果。</p>
<p>例如，在数据集中的正、负例的样本分别为100和10000条，比例为1:100。此时可以将负例样本（类别中的大量样本集）随机分为100份（当然也可以分更多），每份100条数据；然后每次形成训练集时使用所有的正样本（100条）和随机抽取的负样本（100条）形成新的数据集。如此反复可以得到100个训练集和对应的训练模型。</p>
<p>这种解决问题的思路类似于随机森林。在随机森林中，虽然每个小决策树的分类能力很弱，但是通过大量的&ldquo;小树&rdquo;组合形成的&ldquo;森林&rdquo;具有良好的模型预测能力。</p>
<p>如果计算资源充足，并且对于模型的时效性要求不高的话，这种方法比较合适。</p>
<h3>3.4.2.4 通过特征选择</h3>
<p>上述几种方法都是基于数据行的操作，通过多种途径来使得不同类别的样本数据行记录均衡。除此以外，还可以考虑使用或辅助于基于列的特征选择方法。</p>
<p>一般情况下，样本不均衡也会导致特征分布不均衡，但如果小类别样本量具有一定的规模，那么意味着其特征值的分布较为均匀，可通过选择具有显著型的特征配合参与解决样本不均衡问题，也能在一定程度上提高模型效果。</p>
<p>提示 上述几种方法的思路都是基于分类问题解决的。实际上，这种从大规模数据中寻找罕见数据的情况，也可以使用非监督式的学习方法，例如使用One-class SVM进行异常检测。分类是监督式方法，前期是基于带有标签（Label）的数据进行分类预测；而采用非监督式方法，则是使用除了标签以外的其他特征进行模型拟合，这样也能得到异常数据记录。所以，要解决异常检测类的问题，先是考虑整体思路，然后再考虑方法模型。</p>
<h2>3.4.3 代码实操：Python处理样本不均衡</h2>
<p>本示例中，我们主要使用一个新的专门用于不平衡数据处理的Python包imbalanced-learn，读者需要先在系统终端的命令行使用pip install imbalanced-learn进行安装；安装成功后，在Python或IPython命令行窗口通过使用import imblearn（注意导入的库名）检查安装是否正确，示例代码包版本为0.2.1。除此以外，我们还会使用sklearn的SVM在算法中通过调整类别权重来处理样本不均衡问题。本示例使用的数据源文件data2.txt位于&ldquo;附件-chapter3&rdquo;中，默认工作目录为&ldquo;附件-chapter3&rdquo;（如果不是，请cd切换到该目录下，否则会报&ldquo;IOError: File data2.txt does not exist&rdquo;）。完整代码如下：</p>
<div>
<div>
<pre class="prettyprint linenums">import pandas as pd<br />
from imblearn.over_sampling import SMOTE # 过抽样处理库SMOTE<br />
from imblearn.under_sampling import RandomUnderSampler # 欠抽样处理库RandomUnderSampler<br />
from sklearn.svm import SVC #SVM中的分类算法SVC<br />
from imblearn.ensemble import EasyEnsemble # 简单集成方法EasyEnsemble

# 导入数据文件<br />
df = pd.read_table('data2.txt', sep=' ', names=['col1', 'col2','col3', 'col4', 'col5', 'label']) # 读取数据文件<br />
x = df.iloc[:, :-1] # 切片，得到输入x<br />
y = df.iloc[:, -1] # 切片，得到标签y<br />
groupby_data_orgianl = df.groupby('label').count() # 对label做分类汇总<br />
print (groupby_data_orgianl) # 打印输出原始数据集样本分类分布

# 使用SMOTE方法进行过抽样处理<br />
model_smote = SMOTE() # 建立SMOTE模型对象<br />
x_smote_resampled, y_smote_resampled = model_smote.fit_sample(x,y) # 输入数据并作过抽样处理<br />
x_smote_resampled = pd.DataFrame(x_smote_resampled, columns=['col1','col2', 'col3', 'col4', 'col5']) # 将数据转换为数据框并命名列名<br />
y_smote_resampled = pd.DataFrame(y_smote_resampled,columns=['label']) # 将数据转换为数据框并命名列名<br />
smote_resampled = pd.concat([x_smote_resampled, y_smote_resampled],axis=1) # 按列合并数据框<br />
groupby_data_smote = smote_resampled.groupby('label').count() # 对label做分类汇总<br />
print (groupby_data_smote) # 打印输出经过SMOTE处理后的数据集样本分类分布

# 使用RandomUnderSampler方法进行欠抽样处理<br />
model_RandomUnderSampler = RandomUnderSampler() # 建立RandomUnderSampler模型对象<br />
x_RandomUnderSampler_resampled, y_RandomUnderSampler_resampled =model_RandomUnderSampler.fit_sample(x,y) # 输入数据并作欠抽样处理<br />
x_RandomUnderSampler_resampled =pd.DataFrame(x_RandomUnderSampler_resampled,columns=['col1','col2','col3','col4','col5'])<br />
# 将数据转换为数据框并命名列名<br />
y_RandomUnderSampler_resampled =pd.DataFrame(y_RandomUnderSampler_resampled,columns=['label']) # 将数据转换为数据框并命名列名<br />
RandomUnderSampler_resampled =pd.concat([x_RandomUnderSampler_resampled, y_RandomUnderSampler_resampled], axis= 1) # 按列合并数据框<br />
groupby_data_RandomUnderSampler =RandomUnderSampler_resampled.groupby('label').count() # 对label做分类汇总<br />
print (groupby_data_RandomUnderSampler) # 打印输出经过RandomUnderSampler处理后的数据集样本分类分布

# 使用SVM的权重调节处理不均衡样本<br />
model_svm = SVC(class_weight='balanced') # 创建SVC模型对象并指定类别权重<br />
model_svm.fit(x, y) # 输入x和y并训练模型

# 使用集成方法EasyEnsemble处理不均衡样本<br />
model_EasyEnsemble = EasyEnsemble() # 建立EasyEnsemble模型对象<br />
x_EasyEnsemble_resampled, y_EasyEnsemble_resampled =<br />
model_EasyEnsemble.fit_sample(x, y) # 输入数据并应用集成方法处理<br />
print (x_EasyEnsemble_resampled.shape) # 打印输出集成方法处理后的x样本集概况<br />
print (y_EasyEnsemble_resampled.shape) # 打印输出集成方法处理后的y标签集概况

# 抽取其中一份数据做审查<br />
index_num = 1 # 设置抽样样本集索引<br />
x_EasyEnsemble_resampled_t =pd.DataFrame(x_EasyEnsemble_resampled[index_num],columns=['col1','col2','col3','col4','col5'])<br />
# 将数据转换为数据框并命名列名<br />
y_EasyEnsemble_resampled_t =pd.DataFrame(y_EasyEnsemble_resampled[index_num],columns=['label']) # 将数据转换为数据框并命名列名<br />
EasyEnsemble_resampled = pd.concat([x_EasyEnsemble_resampled_t,<br />
y_EasyEnsemble_resampled_t], axis = 1) # 按列合并数据框<br />
groupby_data_EasyEnsemble =EasyEnsemble_resampled.groupby('label').count() # 对label做分类汇总<br />
print (groupby_data_EasyEnsemble) # 打印输出经过EasyEnsemble处理后的数据集样本分类分布</pre>
</div>
</div>
<p>示例代码以空行分为6部分。</p>
<p>第一部分导入库。本示例中用到了第三方库imbalanced-learn实现主要的样本不均衡处理，而pandas的引入主要用于解释和说明不同处理方法得到的结果集样本的分布情况，sklearn.svm中的SVC主要用于说明SVM如何在算法中自动调整分类权重。</p>
<p>第二部分导入数据文件。该过程中使用pandas的read_table读取本地文件，为了更好的区别不同的列，通过names指定列名；对数据框做切片分割得到输入的x和目标变量y；通过pandas的groupby()方法按照label类做分类汇总，汇总方式是使用count()函数计数。输入原始数据集样本分类分布如下：</p>
<div>
<pre class="prettyprint linenums">col1 col2 col3 col4 col5 label<br />
0.0 942 942 942 942 942<br />
1.0 58 58 58 58 58</pre>
</div>
<p>输出结果显示了原始数据集中，正样本（label为1）的数量仅有58个，占总样本量的5.8%，属于严重不均衡分布。</p>
<p>第三部分使用SMOTE方法进行过抽样处理。该过程中首先建立SMOTE模型对象，并直接应用fit_sample对数据进行过抽样处理，如果要获得有关smote的具体参数信息，可先使用fit(x,y)方法获得模型信息，并得到模型不同参数和属性；从fit_sample方法分别得到对x和y过抽样处理后的数据集，将两份数据集转换为数据框然后合并为一个整体数据框；最后通过pandas提供的groupby()方法按照label类做分类汇总，汇总方式是使用count()函数计数。经过SMOTE处理后的数据集样本分类分布如下：</p>
<div>
<pre class="prettyprint linenums">col1 col2 col3 col4 col5 label<br />
0.0 942 942 942 942 942<br />
1.0 942 942 942 942 942</pre>
</div>
<p>通过对比第二部分代码段的原始数据集返回结果发现，该结果中的正样本（label为1）的数量增加，并与负样本数量相同，均为942条，数据分类样本得到平衡。</p>
<p>第四部分使用RandomUnderSampler方法进行欠抽样处理。该过程与第三部分步骤完全相同，在此略过各模块介绍，用途都已在代码备注中注明。经过RandomUnderSampler处理后的数据集样本分类分布如下：</p>
<div>
<pre class="prettyprint linenums">col1 col2 col3 col4 col5 label<br />
0.0 58 58 58 58 58<br />
1.0 58 58 58 58 58</pre>
</div>
<p>通过对比第二部分代码段的原始数据集返回的结果，该结果中的负样本（label为0）的数量减少，并跟正样本相同，均为58条，样本得到平衡。</p>
<p>第五部分使用SVM的权重调节处理不均衡样本。该过程主要通过配置SVC中的class_weight参数和值的设置来处理样本权重，该参数可设置为字典、None或字符串balanced三种模式：</p>
<ul><li>字典：通过手动指定的不同类别的权重，例如{1:10,0:1}</li>
<li>None：代表类别的权重相同</li>
<li>balanced：代表算法将自动调整与输入数据中的类频率成反比的权重，具体公式为n_samples /（n_classes * np.bincount（y）），程序示例中使用了该方法</li></ul>
<p>经过设置后，算法自动处理样本分类权重，无需用户做其他处理。要对新的数据集做预测，只需要调用model_svm模型对象的predict方法即可。</p>
<p>第六部分使用集成方法EasyEnsemble处理不均衡样本。该方法的主要过程与其他imblearn方法过程类似，不同点在于集成方法返回的数据为三维数据，即将数据在原来的基础上新增了一个维度&mdash;&mdash;&ldquo;份数&rdquo;，集成方法返回的数据x和y的形状为(10, 116, 5)和(10, 116)。为了更详细的查看其中每一份数据，抽取其中一份数据做审查，得到的每份数据返回结果如下：</p>
<div>
<pre class="prettyprint linenums">col1 col2 col3 col4 col5 label<br />
0.0 58 58 58 58 58<br />
1.0 58 58 58 58 58</pre>
</div>
<p>通过对比第二部分代码段的原始数据集返回的结果，该结果中的负样本（label为0）的数量减少，并跟正样本相同，均为58条，样本集得到平衡。随后的应用中，可以通过循环读取每一份数据训练模型并得到结果，然后将10（x处理后返回的结果，通过形状名年龄返回的元组中的第一个数值，x_EasyEnsemble_resampled.shape[0]）份数据的结果通过一定方法做汇总。</p>
<p>上述过程中，主要需要考虑的关键点是：</p>
<ul><li>如何针对不同的具体场景选择最合适的样本均衡解决方案，选择过程中既要考虑到每个类别样本的分布情况以及总样本情况，又要考虑后续数据建模算法的适应性，以及整个数据模型计算的数据时效性。</li></ul>
<p>代码实操小结：本小节示例中，主要用了几个知识点：</p>
<ul><li>通过pandas的read_table方法读取文本数据文件，并指定列名</li>
<li>对数据框做切片处理</li>
<li>通过pandas提供的groupby()方法配合count()做分类汇总</li>
<li>使用imblearn.over_sampling中的SMOTE做过抽样处理</li>
<li>使用imblearn.under_sampling中的RandomUnderSampler做欠抽样处理</li>
<li>使用imblearn.ensemble中的EasyEnsemble做集成处理</li>
<li>使用sklearn.svm 中的SVC自动调整算法对不同类别的权重设置</li></ul>
<p>提示 第三方库imblearn提供了非常多的样本不均衡处理方法，限于篇幅无法做一一介绍，建议读者自行安装并学习和了解不同的用法。</p>
<p>其它参考：</p>
<p><a href="https://elitedatascience.com/imbalanced-classes" rel="external nofollow noreferrer">How to Handle Imbalanced Classes in Machine Learning</a>&nbsp; （译文<a href="https://yq.aliyun.com/articles/226016" rel="external nofollow noreferrer">https://yq.aliyun.com/articles/226016</a>）</p>
<p><a href="https://www.cnblogs.com/laiqun/p/6248784.html" rel="external nofollow noreferrer">https://www.cnblogs.com/laiqun/p/6248784.html</a></p>
<p><a href="https://blog.csdn.net/login_sonata/article/details/54290402" rel="external nofollow noreferrer">https://blog.csdn.net/login_sonata/article/details/54290402</a></p>
<p><a href="http://www.cnblogs.com/lyr2015/p/8711120.html" rel="external nofollow noreferrer">http://www.cnblogs.com/lyr2015/p/8711120.html</a></p>
<p><a href="https://blog.csdn.net/weixin_42243942/article/details/80480313" rel="external nofollow noreferrer">https://blog.csdn.net/weixin_42243942/article/details/80480313</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390rg4m9.html">创建ASP&period;NET Core MVC应用程序&lpar;3&rpar;-基于Entity Framework Core&lpar;Code First&rpar;创建MySQL数据库表</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ozoml9.html">ECMAScript &mdash;&mdash; 学习笔记（思维导图版）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zmpw39.html">web页面自适应手机屏幕宽度</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdz6y48.html">php删除多重数组对象属性，重新赋值的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xxog68.html">Go语言并发与并行学习笔记&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m7k1gq.html">使用&commat;RequestParam绑定请求参数到方法参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj3jz49.html">useradd命令详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdez60j9.html">UrlRewriter&period;dll伪静态实现二级域名泛解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z3jmz9.html">linux loadavg详解（top cpu load）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p3k2n8.html">万恶的tileMap</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkeg6z8.html">java做单用户的多重并发会话数限制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1on6yq.html">Vue项目搭建及原理三</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp7ldjq.html">五、OpenStack&mdash;nova组件介绍与安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1kveeq.html">Linux学习第一天&mdash;&mdash;&mdash;&mdash;了解root用户和基本的shell命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjrye59.html">NHibernate删除数据时遇到deleted object would be re-saved by cascade级联问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j62p0q.html">&lpar;网页&rpar;web性能优化&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1j6me9.html">python绘制很美丽的图表</a>
		</li>
						<li><a href="https://www.batexi.com/a/95332w08.html">Android中利用C&plus;&plus;处理Bitmap对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vp20zq.html">luogu P2114 &lbrack;NOI2014&rsqb;起床困难综合症 位运算 二进制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvr13mq.html">quartz---的一个简单例子</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rnyr74q.html">Windows 10 无法调节亮度的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjl7508.html">Java中Arrays 与 Collections 的简单操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kmloxq.html">hdu 5525 Product 数论算贡献</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl5gxk9.html">cannot marshal None unless allow&lowbar;none is enabled</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4vzelq.html">javascript变量声明及作用域总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/902jzo4q.html">手动添加 launcher 到 Ubuntu Unity</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnyor7q.html">通过修改manifest文件来解决Vista&sol;Win7&sol;Win8&sol;win10下应用程序兼容性问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8konwwjq.html">新概念 Lesson 5 How are you today</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2o0l08.html">20161210xlVBA一行数据转为四行</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmny2e9.html">一个登陆浏览api接口； 其他相关： Form&lowbar;with参数的不同写法； 简单使用curl。</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
